import { NextFunction, Response, Request } from "express";
import { Context } from "./options";
import ApiResponse from "./response";

export function catcher(handler: Function): any {
    return function(req: Request, res: Response, next: NextFunction) {
        const context: Context = {
            body: req.body,
            query: req.query,
            headers: req.headers,
            params: req.params,
            req, res, next,
            response: new ApiResponse(res),
            json: (arg: any) => res.json(arg)
        }
        return Promise.resolve(handler(context)).catch(next)
    }
}
