import { Response } from "express"

interface ApiResponseMethod {
    json(arg: any): void
    setCookie(key: string, value: any): ApiResponse
    setHeader(key: string, value: any): ApiResponse
    status(statusCode: number): ApiResponse
}

export default class ApiResponse implements ApiResponseMethod {
    res: Response
    constructor(res: Response) {
        this.res = res
    }
    json(arg: any): void {
        this.res.json(arg)
    }
    setCookie(key: string, value: any): ApiResponse {
        this.res.setHeader(key, value)
        return this
    }
    setHeader(key: string, value: any): ApiResponse {
        this.res.set(key, value)
        return this
    }
    status(statusCode: number): ApiResponse {
        this.res.status(statusCode)
        return this
    }
}
